import {
  Avatar,
  Badge,
  Box,
  Button,
  HStack,
  Input,
  Link,
  Text,
  Tooltip,
  useBoolean,
  useDisclosure,
  useToast,
} from "@chakra-ui/react";
import React, { useContext, useEffect, useState } from "react";
import { CheckIcon, CloseIcon, ExternalLinkIcon } from "@chakra-ui/icons";
import Pagination from "../../Components/Pagination";
import GlobalStateContext from "../../Contexts/GlobalStateContext";
import CustomAlertDialog from "../../Components/CustomAlertDialog";
import NormalTable from "../../Components/DataTable/NormalTable";
import { generateSerialNumber } from "../../Constants/Constants";
import { TABLE_PAGINATION } from "../../Constants/Paginations";
import { OPACITY_ON_LOAD } from "../../Layout/animations";
import { useGetFawateerForMakerRequestQuery } from "../../Services/fawateer.request.service";
import ConfirmModal from "./ConfirmModal";
import RejectModal from "./RejectModal";
import {
  useApproveFawateerRequestMutation,
  useGetFawateerDepositMasterQuery,
  useRejectFawateerRequestMutation,
} from "../../Services/reversal.fawateer.deposit.service";
import RejectReversalPopups from "../../Components/Popups/RejectReversalPopups";
import ToastBox from "../../Components/ToastBox";
import ConfirmReversalPopups from "../../Components/Popups/ConfirmReversalPopups";

const ReversalFawateerDeposit = () => {
  const toast = useToast();
  const { slideFromRight, approveHistory, setApproveHistory } =
    useContext(GlobalStateContext);
  const [searchTerm, setSearchTerm] = useState("");
  const [isLoading, setIsLoading] = useState(true);
  const [deleteAlert, setDeleteAlert] = useState(false);
  const [actionId, setActionId] = useState(false);
  const [mouseEntered, setMouseEntered] = useState(false);
  const [mouseEnteredId, setMouseEnteredId] = useState("");
  const [debouncedSearchTerm, setDebouncedSearchTerm] = useState("");
  const [isReversalLoading, setIsReversalLoading] = useBoolean();

  const [rejectFawateerRequest] = useRejectFawateerRequestMutation();

  const [approveFawateerRequest] = useApproveFawateerRequestMutation();

  const [pageSize, setPageSize] = useState(TABLE_PAGINATION?.size);
  const [currentPage, setCurrentPage] = useState(TABLE_PAGINATION?.page);

  const formatDate = (date) => {
    return new Date(date).toLocaleDateString("en-GB", {
      day: "2-digit",
      month: "2-digit",
      year: "numeric",
    });
  };

  const {
    isOpen: isConfirmOpen,
    onOpen: onConfirmOpen,
    onClose: onConfirmClose,
  } = useDisclosure();
  const {
    isOpen: isRejectOpen,
    onOpen: onRejectOpen,
    onClose: onRejectClose,
  } = useDisclosure();

  const {
    data,
    isLoading: drawalRequestLoading,
    error,
    refetch,
  } = useGetFawateerDepositMasterQuery(
    {
      page: debouncedSearchTerm ? undefined : currentPage, // Omit pagination for search
      size: debouncedSearchTerm ? undefined : pageSize, // Omit pagination for search
      search: debouncedSearchTerm,
    },
    {
      skip: debouncedSearchTerm === "" && searchTerm !== "", // Skip if search is empty and it's not the initial request
    }
  );

  useEffect(() => {
    const handler = setTimeout(() => {
      setDebouncedSearchTerm(searchTerm);
    }, 500); // Adjust delay as needed
    return () => {
      clearTimeout(handler);
    };
  }, [searchTerm]);

  // Use useEffect to refetch data when the component mounts
  useEffect(() => {
    refetch();
  }, [refetch]);

  useEffect(() => {
    // Simulate loading
    const timer = setTimeout(() => {
      setIsLoading(false);
    }, 1500);

    // Cleanup the timer on component unmount
    return () => clearTimeout(timer);
  }, []);

  // ====================================================[Table Filter]================================================================
  const filteredData = data?.data?.rows?.filter((item) => {
    // Filter by name (case insensitive)
    const name = item.principal?.firstName;
    const searchLower = searchTerm.toLowerCase();
    const nameMatches = name.toLowerCase().includes(searchLower);

    return nameMatches;
  });

  // ====================================================[Table Setup]================================================================
  const tableHeadRow = [
    "Sr.no",
    "Request Date",
    "Client ID",
    "First Name",
    "Last Name",
    "Phone Number",
    "Deposit Amount (BHD)",
    "Action",
  ];

  const extractedArray = data?.data?.rows?.map((item, idx) => ({
    // id: item?.id,
    "Sr.no": (
      <Text
        w={"auto"}
        justifyContent={slideFromRight ? "right" : "left"}
        as={"span"}
        color={"teal.900"}
        fontWeight={"500"}
        className="d-flex align-items-center web-text-small"
      >
        {generateSerialNumber(idx, currentPage, pageSize)}
      </Text>
    ),
    "Request Date": (
      <Text
        w={"60px"}
        justifyContent={slideFromRight ? "right" : "left"}
        as={"span"}
        color={"teal.900"}
        fontWeight={"500"}
        className="d-flex align-items-center web-text-small"
      >
        {formatDate(item?.transaction_details?.isReversalDate)}
      </Text>
    ),
    "Client ID": (
      <Text
        w={"60px"}
        justifyContent={slideFromRight ? "right" : "left"}
        as={"span"}
        color={"teal.900"}
        fontWeight={"500"}
        className="d-flex align-items-center web-text-small"
      >
        {item?.principal?.investor_details?.clientReference_id}
      </Text>
    ),
    "First Name": (
      <Box isTruncated={true} w={"80px"}>
        <Text as={"span"} color={"teal.900"} fontWeight={"500"}>
          {item?.principal?.firstName}
        </Text>
      </Box>
    ),
    "Last Name": (
      <Box isTruncated={true}>
        <Text as={"span"} color={"teal.900"}>
          {item?.principal?.lastName}
        </Text>
      </Box>
    ),
    "Phone Number": (
      <Box w={"100px"} isTruncated={true}>
        <Text as={"span"} color={"teal.900"}>
          {/* {item?.principal?.ISDcode} {item?.principal?.mobileNumber} */}
          {item?.principal?.ISDcode + " " + item?.principal?.mobileNumber}
        </Text>
      </Box>
    ),
    "Deposit Amount (BHD)": (
      <Box isTruncated={true}>
        <Text as={"span"} color={"teal.900"} textAlign={"right"}>
          {parseFloat(item?.transaction_details?.investorAmount || 0).toLocaleString(undefined, {
            minimumFractionDigits: 2,
            maximumFractionDigits: 2,
          })}
          <Badge ms={1} colorScheme="green">
            {item?.currencyCode}
          </Badge>
        </Text>
      </Box>
    ),
    Action: (
      <Box display={"flex"} justifyContent={"center"} gap={2}>
        <Tooltip
          rounded={"sm"}
          fontSize={"xs"}
          label="Approve"
          bg="#fff"
          color={"green.500"}
          placement="left-start"
        >
          <Button
            rounded={"sm"}
            size={"xs"}
            textTransform={"inherit"}
            fontWeight={500}
            px={2}
            py={1}
            onClick={() => {
              setActionId(item.id);
              onConfirmOpen();
            }}
            colorScheme="green"
            variant={"solid"}
            cursor={"pointer"}
          >
            <CheckIcon fontSize={"12px"} />
          </Button>
        </Tooltip>
        <Tooltip
          rounded={"sm"}
          fontSize={"xs"}
          label="Reject"
          bg="#fff"
          color={"red.500"}
          placement="left-start"
        >
          <Button
            colorScheme="red"
            // color="red.500"
            rounded={"sm"}
            size={"xs"}
            textTransform={"inherit"}
            fontWeight={500}
            px={2}
            onClick={() => {
              setActionId(item.id);
              onRejectOpen();
            }}
            py={1}
            // variant={"solid"}
          >
            <CloseIcon fontSize={"10px"} />
          </Button>
        </Tooltip>
      </Box>
    ),
  }));

  const handleDelete = () => {
    const updatedSponsors = sponser.filter(
      (sponsor) => sponsor.id !== actionId
    );

    setTimeout(() => {
      setSponser(updatedSponsors);
      setDeleteAlert(false);
      setIsLoading(false);
    }, 100);
    setIsLoading(true);
  };

  const handleApproved = async (data) => {
    setIsReversalLoading.on(); // Start loading
    try {
      const { error, data: responseData } = await rejectFawateerRequest({
        id: actionId,
        data,
      });

      if (error) {
        throw error; // Explicitly handle the error
      }

      // Success: Perform necessary actions
      refetch();
      toast({
        render: () => (
          <ToastBox message={responseData?.message || "Action successful!"} />
        ),
      });
      onRejectClose();
    } catch (error) {
      // Handle errors
      toast({
        render: () => (
          <ToastBox
            message={
              error?.data?.message || "Something went wrong. Please try again."
            }
            status="error"
          />
        ),
      });
      console.error("Error:", error);
    } finally {
      setIsReversalLoading.off(); // Ensure loading is toggled off
    }
  };

  const handleConfirm = async (data) => {
    setIsReversalLoading.on(); // Start loading
    try {
      const { error, data: responseData } = await approveFawateerRequest({
        id: actionId,
        data,
      });

      if (error) {
        throw error; // Explicitly handle the error
      }

      // Success: Perform necessary actions
      refetch();
      toast({
        render: () => (
          <ToastBox message={responseData?.message || "Action successful!"} />
        ),
      });
      onRejectClose();
    } catch (error) {
      // Handle errors
      toast({
        render: () => (
          <ToastBox
            message={
              error?.data?.message || "Something went wrong. Please try again."
            }
            status="error"
          />
        ),
      });
      console.error("Error:", error);
    } finally {
      setIsReversalLoading.off(); // Ensure loading is toggled off
    }
  };

  return (
    <Box {...OPACITY_ON_LOAD} overflowY={"scroll"} height={"100vh"} pb={38}>
      <Box bg="white.500">
        <HStack
          display={"flex"}
          justifyContent={"space-between"}
          ps={1}
          pe={1}
          pb={4}
          pt={4}
          spacing="24px"
        >
          <Input
            type="search"
            width={300}
            placeholder="Search..."
            size="sm"
            rounded="sm"
            focusBorderColor="green.500"
            value={searchTerm}
            onChange={(e) => setSearchTerm(e.target.value)}
          />

          <Pagination
            isLoading={drawalRequestLoading}
            pageSize={pageSize}
            setPageSize={setPageSize}
            currentPage={currentPage}
            setCurrentPage={setCurrentPage}
            totalItems={data?.data?.totalItems}
          />
        </HStack>
      </Box>

      <NormalTable
        isLoading={drawalRequestLoading}
        emptyMessage={`We don't have any Sponers `}
        tableHeadRow={tableHeadRow}
        data={extractedArray}
        viewActionId={actionId}
        setViewActionId={setActionId}
        // totalPages={10}

        setMouseEnteredId={setMouseEnteredId}
        setMouseEntered={setMouseEntered}
      />

      <CustomAlertDialog
        onClose={() => setDeleteAlert(false)}
        isOpen={deleteAlert}
        message={"Are you sure you want to delete sponers?"}
        alertHandler={handleDelete}
        isLoading={isLoading}
      />
      <ConfirmReversalPopups
        isOpen={isConfirmOpen}
        onClose={onConfirmClose}
        handleConfirm={handleConfirm}
        isLoading={isReversalLoading}
      />
      <RejectReversalPopups
        isOpen={isRejectOpen}
        onClose={onRejectClose}
        handelApproved={handleApproved}
        isLoading={isReversalLoading}
      />
    </Box>
  );
};

export default ReversalFawateerDeposit;
